map = {}

function love.load()
	
	mouse = {}
	
	resources = {}
	resources.stone = 9
	resources.ruby = 0
	resources.emerald = 0
	resources.diamond = 1
	resources.image = {}
	resources.image.stone = love.graphics.newImage("stone.png")
	resources.image.ruby = love.graphics.newImage("rubyItem.png")
	resources.image.emerald = love.graphics.newImage("emeraldItem.png")
	resources.image.diamond = love.graphics.newImage("diamondItem.png")
	
	map.tile = {}
	map.tile.x = 0
	map.tile.y = 4
	map.tile.image = {}
	map.tile.image.dirt = love.graphics.newImage("dirt.png")
	map.tile.image.dirttop  = love.graphics.newImage("dirt_top.png")
	map.tile.image.stone1 = love.graphics.newImage("stone1.png")
	map.tile.image.stone2 = love.graphics.newImage("stone2.png")
	map.tile.image.ruby = love.graphics.newImage("ruby.png")
	map.tile.image.emerald = love.graphics.newImage("emerald.png")
	map.tile.image.diamond = love.graphics.newImage("diamond.png")
	map.tile.image.selected = love.graphics.newImage("selected.png")
	
	building = {}
	building.construction = {}
	building.construction.built = false
	building.construction.unlocked = true
	
end

function love.update()
	
	mouse.x = love.mouse.getX()
	mouse.y = love.mouse.getY()
	
	if map.tile.x < 20
	and map.tile.y == 4 then
		
		table.insert(map,{tile = 0, type = "nil", x = map.tile.x * 64, y = map.tile.y * 64})
		map.tile.x = map.tile.x + 1
		
	elseif map.tile.x < 20
	and map.tile.y == 5 then
		
		table.insert(map,{tile = 1, type = "nil", x = map.tile.x * 64, y = map.tile.y * 64})
		map.tile.x = map.tile.x + 1
		
	elseif map.tile.x < 20
	and map.tile.y > 5
	and map.tile.y < 10 then
		
		table.insert(map,{tile = love.math.random(1,100), type = "nil", x = map.tile.x * 64, y = map.tile.y * 64})
		map.tile.x = map.tile.x + 1
		
	end
	
	if map.tile.x == 20 then
		
		map.tile.y = map.tile.y + 1
		map.tile.x = 0
		
	end
	
	if building.construction.unlocked == true
	and building.construction.built == false then
		
		table.insert(building, {level = 1, x = 9 * 64, y = 2 * 64 + 10, img = love.graphics.newImage("construction shed lv.1.png")})
		
	end
	
end

function love.draw()
	
	for i, v in ipairs(building) do
		
		love.graphics.draw(v.img,v.x,v.y)
		
	end
	
	for i,v in ipairs(map) do
		
		if v.tile == 0 then
			
			love.graphics.draw(map.tile.image.dirttop, v.x, v.y)
			v.type = "dirt[top]"
			
		elseif v.tile <= 50 then
			
			love.graphics.draw(map.tile.image.dirt, v.x, v.y)
			v.type = "dirt"
			
		elseif v.tile <= 65 then
			
			love.graphics.draw(map.tile.image.stone1, v.x, v.y)
			v.type = "stone[small]"
			
		elseif v.tile <= 75 then
			
			love.graphics.draw(map.tile.image.stone2, v.x, v.y)
			v.type = "stone[large]"
			
		elseif v.tile <= 85 then
			
			love.graphics.draw(map.tile.image.ruby, v.x, v.y)
			v.type = "ruby"
			
		elseif v.tile <= 95 then
			
			love.graphics.draw(map.tile.image.emerald, v.x, v.y)
			v.type = "emerald"
			
		elseif v.tile <= 100 then
			
			love.graphics.draw(map.tile.image.diamond, v.x, v.y)
			v.type = "diamond"
			
		end
		
	end
	
	for i, v in ipairs(map) do
		
		if mouse.x > v.x
		and mouse.x < v.x + 64
		and mouse.y > v.y
		and mouse.y < v.y + 64 then
			
			love.graphics.draw(map.tile.image.selected, v.x,v.y)
			love.graphics.print(v.type)
			
			if love.mouse.isDown(1)
			and v.tile > 50 then
				
				if v.tile <= 65 then
					
					resources.stone = resources.stone + 1
					
				elseif v.tile <= 75 then
					
					resources.stone = resources.stone + 2
					
				elseif v.tile <= 85 then
					
					resources.ruby = resources.ruby + 1
					
				elseif v.tile <= 95 then
					
					resources.emerald = resources.emerald + 1
					
				elseif v.tile <= 100 then
					
					resources.diamond = resources.diamond + 1
					
				end
				
				v.tile = 1
				
			end
			
		end
		
	end
	
	love.graphics.draw(resources.image.stone, 100, 10)
	love.graphics.print(resources.stone, 170, 42)
	love.graphics.print("stone",100,74)
	love.graphics.draw(resources.image.ruby, 225, 10)
	love.graphics.print(resources.ruby, 295, 42)
	love.graphics.print("ruby",225,74)
	love.graphics.draw(resources.image.emerald, 350, 10)
	love.graphics.print(resources.emerald, 420, 42)
	love.graphics.print("emerald",350,74)
	love.graphics.draw(resources.image.diamond, 475, 10)
	love.graphics.print(resources.diamond, 545, 42)
	love.graphics.print("diamond",475,74)
	
	love.graphics.print(mouse.x..", "..mouse.y,mouse.x + 10,mouse.y)
	
end

function love.keypressed(k)
	
	if k == "r" then
		
		for i, v in ipairs(map) do
			
			table.remove(map, i)
			
		end
		
		map.tile.x = 0
		map.tile.y = 4
		
	end
		
end